Description

Consider a single-elimination football tournament involving 2n teams, denoted 1, 2, …, 2n. In each round of the tournament, all teams still in the tournament are placed in a list in order of increasing index. Then, the first team in the list plays the second team, the third team plays the fourth team, etc. The winners of these matches advance to the next round, and the losers are eliminated. After n rounds, only one team remains undefeated; this team is declared the winner.

Given a matrix P = [pij] such that pij is the probability that team i will beat team j in a match determine which team is most likely to win the tournament.

Input

The input test file will contain multiple test cases. Each test case will begin with a single line containing n (1 ≤ n ≤ 7). The next 2n lines each contain 2n values; here, the jth value on the ith line represents pij. The matrix P will satisfy the constraints that pij = 1.0 − pji for all ij, and pii = 0.0 for all i. The end-of-file is denoted by a single line containing the number −1. Note that each of the matrix entries in this problem is given as a floating-point value. To avoid precision problems, make sure that you use either the double data type instead of float.

Output

The output file should contain a single line for each test case indicating the number of the team most likely to win. To prevent floating-point precision issues, it is guaranteed that the difference in win probability for the top two teams will be at least 0.01.

Sample Input

2
0.0 0.1 0.2 0.3
0.9 0.0 0.4 0.5
0.8 0.6 0.0 0.6
0.7 0.5 0.4 0.0
-1

Sample Output

2

Hint

In the test case above, teams 1 and 2 and teams 3 and 4 play against each other in the first round; the winners of each match then play to determine the winner of the tournament. The probability that team 2 wins the tournament in this case is:

P(2 wins)  = P(2 beats 1)P(3 beats 4)P(2 beats 3) + P(2 beats 1)P(4 beats 3)P(2 beats 4)
= p21p34p23 + p21p43p24
= 0.9 · 0.6 · 0.4 + 0.9 · 0.4 · 0.5 = 0.396.

The next most likely team to win is team 3, with a 0.372 probability of winning the tournament.

题意:有2^n支队伍进行比赛,每行给出这支队伍打败各支队伍的几率,求出那支队伍获胜几率最大

思路:

概率DP,递推式:dp[i][j]=sigma(dp[i-1][j]*p[j][k]*dp[i-1][k]),然后判断两支队伍是否相邻

dp[i][j]代表第i轮中,第j支队伍存活的几率

#include <stdio.h>
#include <string.h>
#include <algorithm>
using namespace std; double a[150][150],dp[150][150]; int main()
{
int n,m,i,j,k,ans;
while(~scanf("%d",&n),n+1)
{
m = 1<<n;
for(i = 0; i<m; i++)
for(j = 0; j<m; j++)
scanf("%lf",&a[i][j]);
memset(dp,0,sizeof(dp));
for(i = 0; i<m; i++)//一开始所有队伍都存活
dp[0][i] = 1;
for(i = 1; i<=n; i++)
for(j = 0; j<m; j++)
for(k = 0; k<m; k++)
{
int p = k>>(i-1),q = j>>(i-1);//判断是否相邻
if(p%2)
{
p--;
if(p==q)//判断p前进或后退以为,p==q的话证明他们是相邻的,进行比赛
dp[i][j] += dp[i-1][j]*dp[i-1][k]*a[j][k];//j存活,k存活,j打败k
}
else
{
p++;
if(p==q)
dp[i][j] += dp[i-1][j]*dp[i-1][k]*a[j][k];
}
}
ans = 0;
for(i = 0; i<m; i++)//找最大
{
if(dp[n][ans]<dp[n][i])
ans = i;
}
printf("%d\n",ans+1);
} return 0;
}

最新文章

  1. 自定义可视化调试工具(Microsoft.VisualStudio.DebuggerVisualizers)
  2. JSPatch使用小记
  3. 如何保证Service在后台不被kill
  4. C#6.0特性笔记
  5. net-snmp源码VS2013编译添加加密支持(OpenSSL)(在VS里配置编译OpenSSL)
  6. 【C#】1.2 控制台应用程序学习要点
  7. hdu1016 Prime Ring Problem
  8. BZOJ 1048 分割矩阵
  9. js限制textarea文本框的文字个数
  10. 解决ionic2各种坑文章收集
  11. linux定时器crontab
  12. C++ stl 怎么打印内存内容?
  13. ssl证书专题(2):自签名ssl 证书生成
  14. 分享一个基于ssm框架下的webService接口开发
  15. django中文学习资料
  16. SQL Developer连接Oracle出现“IO 错误:Undefined Error”
  17. for循环的灵活性
  18. android 开发 写一个RecyclerView布局的聊天室,并且添加RecyclerView的点击事件
  19. EF Code First Migrations数据库迁移 (转帖)
  20. 我学习的第一个uiautomator从创建到运行结束

热门文章

  1. QT绘制系统简介
  2. 删除list中指定值的元素
  3. HDU 4362 Dragon Ball 线段树
  4. Linux自动登陆的设置方法
  5. 自制获取data-自定义属性
  6. jquery 处理密码输入框(input type=&quot;password&quot; ) 模仿placeholder
  7. [canvas]通过动态生成像素点做绚丽效果
  8. ios 异步多线程 获取数据
  9. WAMPSERVER2.2 无法启动的解决!
  10. 高可用集群(HA)之DRBD原理和基础配置